class Onades
{

  static final private int N = 20;
  static final private int MAX_ONADES = (N - 1) % N;
  private Tropa tropes[];
  private int numOnades;






  public Onades ()
  {
    tropes = new Tropa[MAX_ONADES];
    int i = 0;
    for (i = 0; i < MAX_ONADES; i++)
        tropes[i] = new Tropa (0, 0);
      numOnades = 0;
  }





  public void afegir_onada (Tropa t) throws Exception
  {
    tropes[numOnades] = t;
    numOnades++;
  }

  public void afegir_onada_individual (int b, int q) throws Exception
  {
    Tropa temp = new Tropa (b, q);
      tropes[numOnades] = temp;
      numOnades++;
  }

  public void suma_dist_a_tots (int d) throws Exception
  {
    for (int i = 0; i < numOnades; i++)
      tropes[i].suma_dist (d);
  }

  public int quantes () throws Exception
  {
    return numOnades;
  }


  public Tropa tropa (int n) throws Exception
  {
    return tropes[n];

  }
  public int distancia (int n) throws Exception
  {
    return tropes[n].distancia ();

  }
  public void fusiona (Onades o1, Onades o2) throws Exception
  {

    int i, j;
      i = 0;
      j = 0;

    while (i < o1.numOnades && j < o2.numOnades)
      {

	if (o1.distancia (i) < o2.distancia (j))
	  {
	    this.afegir_onada (o1.tropa (i));
	    i++;

	  }
	else if (o1.distancia (i) > o2.distancia (j))
	  {
	    this.afegir_onada (o2.tropa (j));
	    j++;

	  }
	else
	  {

//      IO es=new IO(); es.escriu("LLUITA!");
	    Tropa temp = new Tropa (0, 0);
	    temp.lluita (o1.tropa (i), o2.tropa (j));

	    this.afegir_onada (temp);
	    i++;
	    j++;
	  }

      }

    while (i < o1.numOnades)
      {
	this.afegir_onada (o1.tropa (i));
	i++;
      }

    while (j < o2.numOnades)
      {
	this.afegir_onada (o2.tropa (j));
	j++;
      }


  }
  public int lleg_num (int n) throws Exception
  {
    return tropes[n].lleg_num ();
  }
  public int lleg_band (int n) throws Exception
  {
    return tropes[n].lleg_band ();
  }

}
